From 3b69847f521f7743a6cfa9a06db4111c040808d0 Mon Sep 17 00:00:00 2001
From: Mark Dilger <mark.dilger@enterprisedb.com>
Date: Thu, 26 Aug 2021 17:18:05 -0700
Subject: [PATCH v1] Add CHECK_FOR_INTERRUPTS() to verify_heapam()

The verify_heapam() was looping over a potentially large number of
blocks without ever checking for interrupts, preventing a query
cancel.

Fix by inserting a CHECK_FOR_INTERRUPTS() into the loop to check
once per block.
---
 contrib/amcheck/verify_heapam.c | 2 ++
 1 file changed, 2 insertions(+)

diff --git a/contrib/amcheck/verify_heapam.c b/contrib/amcheck/verify_heapam.c
index 226271923a..173f99d787 100644
--- a/contrib/amcheck/verify_heapam.c
+++ b/contrib/amcheck/verify_heapam.c
@@ -395,6 +395,8 @@ verify_heapam(PG_FUNCTION_ARGS)
 	{
 		OffsetNumber maxoff;
 
+		CHECK_FOR_INTERRUPTS();
+
 		/* Optionally skip over all-frozen or all-visible blocks */
 		if (skip_option != SKIP_PAGES_NONE)
 		{
-- 
2.21.1 (Apple Git-122.3)

